##
## reader.py
## Login : <glibersat@localhost.localdomain>
## Started on  Sat Dec 31 00:54:08 2005 Guillaume Libersat
## $Id$
## 
## Copyright (C) 2005 Guillaume Libersat
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##

import struct

class GPBinReader(object):
    def __init__(self, fd):
        self.fd = fd
        
    def read_byte(self):
        return struct.unpack("<b", self.fd.read(1))[0]

    def read_bool(self):
        r = struct.unpack("<b", self.fd.read(1))[0]
        if r == 0:
            return False
        else:
            return True

    def read_long(self):
        return struct.unpack("<l", self.fd.read(4))[0]

    def read_string(self, length):
        string = struct.unpack("%ds"%(length), self.fd.read(length))[0]
        return string

    def read_byte_string(self):
        exp_length = self.read_byte()
        real_length = self.read_byte()
        
        return self.read_string(real_length)

    def read_long_string(self):
        length = self.read_long() - 1
        nb = self.read_byte()

        if length >= 0:
            if length != nb:
                print "aie %d <=> %d" %(length, nb)
                return ""
            else:
                return self.read_string(length)
        else:
            return ""


    def read_lyrics_string(self):
        length = self.read_long()
        if length > 1:
            s = self.read_string(length)
            self.fd.read(4)
        else:
            s = ""

        return s


    def seek(self, off):
        self.fd.seek(off)

